/*
 * Copyright 2012 Phidgets Inc.  All rights reserved.
 */

import com.phidgets.*;
import com.phidgets.event.*;
import java.util.Scanner;

public class CurrentSensorExample
{
	public static final void main(String args[]) throws Exception {
		final InterfaceKitPhidget ik;

		ik = new InterfaceKitPhidget();
		ik.addAttachListener(new AttachListener() {
			public void attached(AttachEvent ae) {
				System.out.println("attachment of " + ae);
			}
		});
		ik.addDetachListener(new DetachListener() {
			public void detached(DetachEvent ae) {
				System.out.println("detachment of " + ae);
			}
		});
		ik.addErrorListener(new ErrorListener() { //error event listener
			public void error(ErrorEvent ee) {
				System.out.println(ee);
			}
		});
		ik.addSensorChangeListener(new SensorChangeListener() { //checks for changes in the sensor measured values
			public void sensorChanged(SensorChangeEvent se) {
				int currentThreshold = 10; //if the measured current is over 10A we want to signal a user
				if(se.getIndex() == 0 && (se.getValue()/40) > currentThreshold) {
					try{
					ik.setOutputState(0, true); //for this example we will turn an LED on when the current reaches the threshold
					}
					catch(Exception e){
					}
				}
				if(se.getIndex() == 0 && (se.getValue()/40) < currentThreshold) {
					try{
					ik.setOutputState(0, false); //for this example we will turn an LED on when the current reaches the threshold
					}
					catch(Exception e){
					}
				}
			}
		});

		ik.openAny();
		System.out.println("waiting for InterfaceKit attachment...");
		ik.waitForAttachment();
		System.out.println(ik.getDeviceName());

		Scanner sc = new Scanner(System.in);
		System.out.println("Press Enter to quit...");
		sc.nextLine();
		
		ik.setOutputState(0,false);
		ik.close();

	}
}
